CLICK(1)

NAME
click - runs router configurations at user level

SYNOPSIS
click [options] [router-file]

DESCRIPTION
The click driver executes a Click modular router specification in a user-level program. It reads a router configuration file, sets up the router according to that file, and generally continues until interrupted. The router configuration is written in the Click language (see and can contain dynamically loadable code, which click will link against before installing the configuration.

The click program can read and write packets from the network using Berkeley Packet Filters -- see and It can also read and write BPF dump files, such as those created by and The element, and others like it, may be useful for testing configurations without affecting the network.

OPTIONS
If any filename argument is a single dash "-", click will use the standard input or output instead, as appropriate.

-f file
--file file
    Read the router configuration from file. The default is the standard input.

-e expr
--expression expr
    Use expr, a string in the Click language, as the router configuration.

-o file
--output file
    Write the router configuration to file with all compound elements removed, and without any additional archive members.

-s[element]
--stop[=element]
    Exit when element is no longer scheduled. Normally, element is a source of packets, and you want the driver to exit as soon as the packet source is exhausted. You can provide multiple --stop options; then click will exit as soon as any one of the elements is no longer scheduled. If you do not provide the element option, the driver will use any and elements in the configuration. This option is useful when profiling a configuration or running the driver from a trace.

-d dir
--directory dir
    Write the output of registered read handlers to dir

-h element.handler
--handler element.handler
    After running the driver, call element's read handler named handler and print the result to standard output. Each element has several generic handlers -- for example, config returns the element's configuration string and class returns the element's class name. Some elements have additional handlers; for example, has count and rate handlers that return the number of packets arrived and the recent arrival rate in packets per second. See for more information on generic handlers, and the element documentation for more information on element-specific handlers.

    element may also be a pattern that uses the shell's globbing syntax (*, ?, and [...]). In this case, click will run every handler whose name is handler and whose element's name matches the pattern.

-q, --quit
    Do not run the driver. This option can be used to check a configuration for errors, or to check handler results (with the --handler option) without running the configuration.

-t, --time
    Print the time it took to run the driver.

--help
    Print usage information and exit.

--version
    Print the version number and some quickie warranty information and exit.

BUGS
If you get an unaligned access error, try running your configuration through first.

SEE ALSO

AUTHOR
Eddie Kohler, eddietwo@lcs.mit.edu
http://www.pdos.lcs.mit.edu/click/